# TODO:
# - mplayer.sh:
#   - patch to allow playing audio files (currently insists to find video)
#   - audio CD support?

%define plugindir %(vdr-config --plugindir  2>/dev/null || echo ERROR)
%define configdir %(vdr-config --configdir  2>/dev/null || echo ERROR)
%define videodir  %(vdr-config --videodir   2>/dev/null || echo ERROR)
%define audiodir  %(vdr-config --audiodir   2>/dev/null || echo ERROR)
%define datadir   %(vdr-config --datadir    2>/dev/null || echo ERROR)
%define cachedir  %(vdr-config --cachedir   2>/dev/null || echo ERROR)
%define vardir    %(vdr-config --vardir     2>/dev/null || echo ERROR)
%define apiver    %(vdr-config --apiversion 2>/dev/null || echo ERROR)
%define vdr_user  %(vdr-config --user       2>/dev/null || echo ERROR)
%define localedir %{plugindir}/locale

Name:           vdr-mp3
Version:        0.10.1
Release:        4
Summary:        Sound playback plugin for VDR

Group:          Multimedia/VDR
License:        GPL
URL:            http://www.muempf.de/
Source0:        http://www.muempf.de/down/%{name}-%{version}.tar.gz
Source1:        http://batleth.sapienti-sat.org/projects/VDR/mplayer.sh-0.8.7.tar.gz
Source2:        %{name}-mediasources.sh
Source3:        %{name}-mp3.conf
Source4:        %{name}-mplayer.conf
Source5:        %{name}-mplayer-minimal.sh
Patch0:         %{name}-mplayer.sh.conf.patch
Patch1:         %{name}-mplayer.sh-framedrop.patch
Patch2:         %{name}-mplayer.sh-identify.patch
Patch3:		vdr-mp3-makefile.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  vdr-devel >= 1.6.0
BuildRequires:  libsndfile-devel >= 1.0.0
BuildRequires:  libvorbis-devel
BuildRequires:  %{__perl}
BuildRequires:  libmad-devel
BuildRequires:  libid3tag-devel
Requires:       vdr(abi) = %{apiver}
Requires:       netpbm
Requires:       mjpegtools >= 1.8.0
Requires:       file

%description
The MP3 plugin adds audio playback capability to VDR.  Supported audio
formats are those supported by libmad, libsndfile and libvorbis.

%package     -n vdr-mplayer
Summary:        MPlayer plugin for VDR
Group:          %{group}
BuildRequires:  %{__perl}
Requires:       vdr(abi) = %{apiver}
Requires:       MPlayer >= 1.0pre8

%description -n vdr-mplayer
The MPlayer plugin adds the ability to call MPlayer from within VDR,
allowing to replay all video formats supported by MPlayer over VDR's
primary output device.


%prep
%setup -q -n mp3-%{version} -a 1
%patch0
%patch1
%patch2
%{__perl} -pi -e \
  's|CFGFIL=.*|CFGFIL="%{configdir}/plugins/mplayer.sh.conf"|' \
  mplayer.sh
%{__perl} -pi -e \
  's|"/var/cache/images/mp3"|"%{cachedir}/mp3/images"|' \
  data-mp3.c README
%{__perl} -pi -e \
  's|"/video/plugins/DVD-VCD"|"%{datadir}/DVD-VCD"|' \
  mplayer.sh.conf
for f in HISTORY MANUAL README ; do
  iconv -f iso-8859-1 -t utf-8 $f > $f.utf-8 ; mv $f.utf-8 $f
done
sed -e 's|/var/lib/vdr|%{vardir}|' %{SOURCE4} > %{name}-mplayer.conf
%patch3 -p1

%build
make %{?_smp_mflags} LIBDIR=. VDRDIR=%{_libdir}/vdr WITH_OSS_OUTPUT=1 libvdr-mp3.so
make %{?_smp_mflags} LIBDIR=. VDRDIR=%{_libdir}/vdr WITH_OSS_OUTPUT=1 libvdr-mplayer.so
echo "%{audiodir};Local hard drive;0" > mp3sources.conf
echo "%{datadir}/DVD-VCD;DVD or VCD;0" > mplayersources.conf

%install
rm -rf $RPM_BUILD_ROOT

# Common dirs
install -dm 755 $RPM_BUILD_ROOT%{plugindir}
install -dm 755 $RPM_BUILD_ROOT%{configdir}/plugins
install -dm 755 $RPM_BUILD_ROOT%{plugindir}/bin
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/vdr-plugins.d
install -dm 755 $RPM_BUILD_ROOT%{localedir}

# i18n files
make %{?_smp_mflags} LIBDIR=. VDRDIR=%{_libdir}/vdr LOCALEDIR=$RPM_BUILD_ROOT%{plugindir}/locale i18n-mp3
make %{?_smp_mflags} LIBDIR=. VDRDIR=%{_libdir}/vdr LOCALEDIR=$RPM_BUILD_ROOT%{plugindir}/locale i18n-mplayer

# Common files
install -pm 755 %{SOURCE2} $RPM_BUILD_ROOT%{plugindir}/bin/mediasources.sh
install -pm 755 examples/mount.sh.example \
  $RPM_BUILD_ROOT%{plugindir}/bin/mount.sh

# MP3 files
install -pm 755 libvdr-mp3.so.%{apiver} $RPM_BUILD_ROOT%{plugindir}
install -pm 644 mp3sources.conf $RPM_BUILD_ROOT%{configdir}/plugins
install -pm 755 examples/image_convert.sh.example \
  $RPM_BUILD_ROOT%{plugindir}/bin/image_convert.sh
%{__perl} -pe 's|/var/cache/vdr/|%{cachedir}/|' %{SOURCE3} \
  > $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/vdr-plugins.d/mp3.conf
chmod 644 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/vdr-plugins.d/mp3.conf
install -dm 755 $RPM_BUILD_ROOT%{cachedir}/mp3/images
i=$RPM_BUILD_ROOT%{cachedir}/mp3/id3info.cache ; > $i ; chmod 644 $i

# MPlayer files
install -pm 755 libvdr-mplayer.so.%{apiver} $RPM_BUILD_ROOT%{plugindir}
install -dm 755 $RPM_BUILD_ROOT%{datadir}/DVD-VCD
touch $RPM_BUILD_ROOT%{datadir}/DVD-VCD/{DVD,VCD}
chmod 644 $RPM_BUILD_ROOT%{datadir}/DVD-VCD/*
install -pm 644 mplayersources.conf mplayer.sh.conf \
  $RPM_BUILD_ROOT%{configdir}/plugins
install -pm 755 mplayer.sh $RPM_BUILD_ROOT%{plugindir}/bin/mplayer.sh
install -pm 755 %{SOURCE5} $RPM_BUILD_ROOT%{plugindir}/bin/mplayer-minimal.sh
install -pm 644 %{name}-mplayer.conf \
  $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/vdr-plugins.d/mplayer.conf
install -dm 755 $RPM_BUILD_ROOT%{vardir}
i=$RPM_BUILD_ROOT%{vardir}/global.mplayer.resume ; > $i ; chmod 644 $i

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ $1 -eq 1 ] ; then
  %{plugindir}/bin/mediasources.sh \
    >> %{configdir}/plugins/mp3sources.conf || :
else
  if ! grep %{audiodir} %{configdir}/plugins/mp3sources.conf &>/dev/null ; then
    echo "%{audiodir}" >> %{configdir}/plugins/mp3sources.conf || :
  fi
  r=global.mplayer.resume
  if [ -f %{videodir}/$r -a ! -f %{vardir}/$r ] ; then
    mv %{videodir}/$r %{vardir}/$r
  fi
fi

%post -n vdr-mplayer
if [ $1 -eq 1 ] ; then
  %{plugindir}/bin/mediasources.sh \
    >> %{configdir}/plugins/mplayersources.conf || :
fi


%files
%defattr(-,root,root,-)
%doc COPYING HISTORY MANUAL README examples/mount.sh.example
%doc examples/mp3sources.conf.example examples/network.sh.example
%config(noreplace) %{configdir}/plugins/mp3sources.conf
%config(noreplace) %{_sysconfdir}/sysconfig/vdr-plugins.d/mp3.conf
%{plugindir}/libvdr-mp3.so.%{apiver}
%{plugindir}/bin/image_convert.sh
%{plugindir}/bin/mediasources.sh
%{plugindir}/bin/mount.sh
%defattr(-,%{vdr_user},root,-)
%dir %{cachedir}/mp3/
%dir %{cachedir}/mp3/images/
%ghost %{cachedir}/mp3/id3info.cache
%{localedir}/*/*/vdr-mp3.mo

%files -n vdr-mplayer
%defattr(-,root,root,-)
%doc COPYING HISTORY MANUAL README examples/mplayer.sh.example
%doc examples/mount.sh.example
%config(noreplace) %{configdir}/plugins/mplayer*.conf
%config(noreplace) %{_sysconfdir}/sysconfig/vdr-plugins.d/mplayer.conf
%{plugindir}/libvdr-mplayer.so.%{apiver}
%{plugindir}/bin/mediasources.sh
%{plugindir}/bin/mount.sh
%{plugindir}/bin/mplayer*.sh
%{datadir}/DVD-VCD/
%defattr(-,%{vdr_user},root,-)
%ghost %{vardir}/global.mplayer.resume
%{localedir}/*/*/vdr-mplayer.mo

%changelog
* Thu Mar 27 2008 Christian Wasem <wasem@ccux-linux.de> 0.10.1-4
- rebuild, VDR 1.6.0
* Sun Mar 16 2008 Christian Wasem <wasem@ccux-linux.de> 0.10.1-3
- rebuild against latest vdr package
* Mon Jan 27 2008 Christian Wasem <wasem@ccux-linux.de> 0.10.1-2
- rebuild against latest vdr package
* Mon Jan 14 2008 Christian Metzen <metzench@ccux-linux.de> 0.10.1-1
- Version update, update mplayer.sh to version that is compatible with new mplayer arguments
* Sat Aug 25 2007 Christian Wasem <wasem@ccux-linux.de> 0.9.15-13
- rebuild against latest vdr package
* Mon Feb 12 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-12
- rebuild against latest vdr package
* Wed Feb 07 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-11
- rebuild against latest vdr package
* Wed Feb 07 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-10
- rebuild against latest vdr package
* Fri Feb 02 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-9
- fixed dependency
* Fri Feb 02 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-8
- rebuild against latest vdr package
* Thu Jan 25 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-7
- rebuild against latest vdr package
* Wed Jan 24 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-6
- rebuild against latest vdr package
* Sat Jan 20 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-5
- rebuild against latest vdr package
* Sat Jan 20 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-4
- rebuild against latest vdr package
* Sat Jan 20 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-3
- rebuild against latest vdr package
* Tue Jan 09 2007 Christian Metzen <metzench@ccux-linux.de> 0.9.15-2
- rebuild against latest VDR
* Tue Oct 17 2006 Christian Metzen <metzench@ccux-linux.de> 0.9.15-1
- Initial release
